<template>
  <span class="StopWatch">
    <span class="StopWatch--human">{{ human }}</span>
    <span class="StopWatch--precise">{{ precise }}</span>
  </span>
</template>

<script lang="ts">
import { defineComponent } from 'vue'
import moment, { duration } from 'moment'

export default defineComponent({
  name: 'StopWatch',
  props: {
    start: {
      type: Date,
      required: true,
    },
    format: {
      type: String,
      default: 'HH:mm:ss',
    },
    now: {
      type: Object,
      required: true,
    },
  },

  computed: {
    human(): string {
      return duration(moment(this.now).diff(this.start)).humanize()
    },
    precise(): string {
      return moment.utc(moment(this.now).diff(this.start)).format(this.format)
    },
  },
})
</script>

<style lang="scss" scoped>
.StopWatch {
  position: relative;
  white-space: pre;

  &--precise {
    position: absolute;
    right: 0;
  }

  &:not(:hover) .StopWatch--precise {
    visibility: hidden;
  }

  &:hover .StopWatch--human {
    visibility: hidden;
  }
}
</style>
